package com.is2t.example;

public class Task implements Runnable {
	// We need to implement the Runnable interface to create a thread
	private final String text;
	private final int countTo;
	private final int delay; // in milliseconds
	// Constructor

	public Task(String text, int countTo, int delay) {
		this.text = text;
		this.countTo = countTo;
		this.delay = delay;
	}

	// The thread will execute this method
	public void run() {
		System.out.println("Thread " + text + " starts...");
		for (int i = 1; i <= countTo; i++) {
			System.out.println(text + " : " + i + "/" + countTo);
			try {
				Thread.sleep(delay);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println("Thread " + text + " ends");
	}

	// Main function, to test the multithreading capability
	public static void main(String[] args) {
		System.out.println("This is a simple application");
		// Create and start threads
		Thread t1 = new Thread(new Task("A", 15, 900));
		Thread t2 = new Thread(new Task("B", 8, 1600));
		Thread t3 = new Thread(new Task("C", 30, 200));
		t1.start();
		t2.start();
		t3.start();
		// Wait for the threads to finish
		try {
			t1.join();
			t2.join();
			t3.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Now, the end");
	}
}
