/*
 * C
 *
 * Copyright 2012 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef __MICROEJ_H
#define __MICROEJ_H

#include <stdint.h>

#define MICROEJ_FALSE 	0
#define MICROEJ_TRUE 	1
#define MICROEJ_INSTANCES_INIT_LINE_END {0,0}

/**
 * A line of instances table. Instances table must end with a null line.
 */
struct MICROEJ_INSTANCES_INIT_LINE{
	/**
	 * Function hook for creating a new instance.
	 * instanceIndex is 0 based.
	 * This function is called from 0 to instances_number-1.
	 */
	void* (*create_instance)(int32_t instance_index);

	/**
	 * Number of instances to be created with the given create_instance function.
	 */
	int32_t instances_number;
};

#endif
